#include <QCoreApplication>
#include <QDebug>
#include <QLibraryInfo>
#include <QSaveFile>
#include <QFile>
#include <QDir>

#include <QStringList>

#include <algorithm>
#include <iostream>

int main(int argc, char *argv[])
{
    QStringList args;
    std::copy(argv + 1, argv + argc, std::back_inserter(args));

    qDebug().noquote() << QLibraryInfo::build() << "\n   " << args;

    bool useQFile = args.removeAll("-f");
    QString path = args.value(0, QString( "\\\\drive\\dir\\myfile.txt" ));

    qDebug().noquote() << "path=" << path;

    {
        QString dirN = path.left(path.lastIndexOf('\\'));
        QFileInfo fi(dirN);
        qDebug().noquote() << fi.exists() << fi.absoluteFilePath();
        if (!fi.exists()) {
            qWarning().noquote() << dirN << "does not exist";
            return -1;
        }
    }

    bool ok;
    if (useQFile) {
        QFile f2( path );
        ok = f2.open( QIODevice::WriteOnly | QIODevice::Truncate | QIODevice::Text );
        if (ok) {
            f2.write("qfile\n");
            qDebug() << "QFile ok";
        } else {
            qDebug() << "QFile f.error()=" << f2.error() << "QFile f.errorString()=" << f2.errorString();
        }
    } else {
        QSaveFile f( path );
        ok = f.open( QIODevice::WriteOnly | QIODevice::Truncate | QIODevice::Text );
        if (ok) {
            ok &= f.write("QSaveFile\n") && f.commit();
            qDebug() << "QSaveFile wrote" << ok;
        } else {
            qDebug() << "QSaveFile f.error()=" << f.error() << "QSaveFile f.errorString()=" << f.errorString();
        }
    }
    return ok ? 0 : -2;
}
